ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.19 by root, Mon Dec 13 17:25:17 2010 UTC vs.
Revision 1.75 by root, Tue Aug 1 03:48:59 2023 UTC

1#!/bin/sh 1#!/bin/sh
2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in (or to replace in your .staticperlrc)
5 5
6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9DLCACHE=
9 10
10# perl build variables 11# perl build variables
11PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 12MAKE=make
13PERL_VERSION=http://stableperl.schmorp.de/dist/latest.tar.gz # 5.12.5 and 5.8.9 are good choices for small builds
12PERL_CC=cc 14PERL_CC=cc
13PERL_CONFIGURE="" # additional Configure arguments 15PERL_CONFIGURE="" # additional Configure arguments
14PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 16PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
15PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 17PERL_OPTIMIZE="-Os" # -Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
16 18
17ARCH="$(uname -m)" 19ARCH="$(uname -m)"
18 20
19case "$ARCH" in 21#case "$ARCH" in
20 i*86 | x86_64 | amd64 ) 22# i*86 | x86_64 | amd64 )
21 #PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64 23# PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64
22 PERL_OPTIMIZE="$PERL_OPTIMIZE" # x86/amd64
23 case "$ARCH" in 24# case "$ARCH" in
24 i*86 ) 25# i*86 )
25 PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only 26# PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only
26 ;; 27# ;;
27 esac 28# esac
28 ;; 29# ;;
29esac 30#esac
30 31
31# -Wl,--gc-sections makes it impossible to check for undefined references 32# -Wl,--gc-sections makes it impossible to check for undefined references
32# for some reason so we need to patch away the "-no" after Configure and before make :/ 33# for some reason so we need to patch away the "-no" after Configure and before make :/
33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug 34# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition" 35#PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
36PERL_LDFLAGS=
35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 37PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
36 38
37# some configuration options for modules 39# some configuration options for modules
38export PERL_MM_USE_DEFAULT=1 40PERL_MM_USE_DEFAULT=1
41PERL_MM_OPT="MAN1PODS= MAN3PODS="
39#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 42#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
40export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 43#EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
44export PERL_MM_USE_DEFAULT PERL_MM_OPT
41 45
42# which extra modules to install by default from CPAN that are 46# which extra modules to install by default from CPAN that are
43# required by mkbundle 47# required by mkbundle
44STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 48STATICPERL_MODULES="ExtUtils::MakeMaker ExtUtils::CBuilder common::sense Pod::Strip PPI PPI::XS Pod::Usage"
45 49
46# which extra modules you might want to install 50# which extra modules you might want to install
47EXTRA_MODULES="" 51EXTRA_MODULES=""
48 52
49# overridable functions 53# overridable functions
50preconfigure() { : ; } 54preconfigure() { : ; }
55patchconfig() { : ; }
51postconfigure() { : ; } 56postconfigure() { : ; }
52postbuild() { : ; } 57postbuild() { : ; }
58postcpanconfig() { : ; }
53postinstall() { : ; } 59postinstall() { : ; }
54 60
55# now source user config, if any 61# now source user config, if any
56if [ "$STATICPERLRC" ]; then 62if [ "$STATICPERLRC" ]; then
57 . "$STATICPERLRC" 63 . "$STATICPERLRC"
58else 64else
62fi 68fi
63 69
64############################################################################# 70#############################################################################
65# support 71# support
66 72
67MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}" 73# work around ExtUtils::CBuilder and others
74export CC="$PERL_CC"
75export CFLAGS="$PERL_CFLAGS"
76export LD="$PERL_CC"
77export LDFLAGS="$PERL_LDFLAGS"
78unset LIBS
79
68PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed 80PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
69 81
70unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG 82unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
83unset PERL_MB_OPT
71export LC_ALL=C # just to be on the safe side 84LC_ALL=C; export LC_ALL # just to be on the safe side
85
86# prepend PATH - not required by staticperl itself, but might make
87# life easier when working in e.g. "staticperl cpan / look"
88PATH="$PERL_PREFIX/perl/bin:$PATH"
72 89
73# set version in a way that Makefile.PL can extract 90# set version in a way that Makefile.PL can extract
74VERSION=VERSION; eval \ 91VERSION=VERSION; eval \
75$VERSION=0.911 92$VERSION="1.46"
76
77BZ2=bz2
78BZIP2=bzip2
79 93
80fatal() { 94fatal() {
81 printf -- "\nFATAL: %s\n\n" "$*" >&2 95 printf -- "\nFATAL: %s\n\n" "$*" >&2
82 exit 1 96 exit 1
83} 97}
123 137
124############################################################################# 138#############################################################################
125# download/configure/compile/install perl 139# download/configure/compile/install perl
126 140
127clean() { 141clean() {
128 rm -rf "$STATICPERL/src/perl-$PERL_VERSION" 142 rm -rf "$STATICPERL/src"
143}
144
145realclean() {
146 rm -f "$PERL_PREFIX/staticstamp.postinstall"
147 rm -f "$PERL_PREFIX/staticstamp.install"
148 rm -f "$STATICPERL/src/perl/staticstamp.configure"
129} 149}
130 150
131fetch() { 151fetch() {
152(
132 rcd "$STATICPERL" 153 rcd "$STATICPERL"
133 154
134 mkdir -p src 155 mkdir -p src
135 rcd src 156 rcd src
136 157
137 if ! [ -d "perl-$PERL_VERSION" ]; then 158 if ! [ -d "perl" ]; then
138 if ! [ -e "perl-$PERL_VERSION.tar.$BZ2" ]; then 159 rm -rf unpack
160 mkdir -p unpack
139 161
162 case "$PERL_VERSION" in
163 *:* )
164 # url
165 PERLURL="$PERL_VERSION"
166 PERLTAR="$(basename "$PERL_VERSION")"
167 ;;
168 /* )
169 # directory
170 verbose "copying $PERL_VERSION"
171 cp -Rp "$PERL_VERSION/." unpack/.
172 chmod -R u+w unpack
173 mv unpack perl
174 return
175 ;;
176 * )
140 URL="$CPAN/src/5.0/perl-$PERL_VERSION.tar.$BZ2" 177 PERLURL="$CPAN/src/5.0/perl-$PERL_VERSION.tar.bz2"
178 PERLTAR=perl-$PERL_VERSION.tar.bz2
179 ;;
180 esac
141 181
182 if ! [ -e "$PERLTAR" ]; then
142 verblock <<EOF 183 verblock <<EOF
143downloading perl 184downloading perl
185
186trying to download from $PERLURL
187
188you can configure a download cache directory via DLCACHE
189in your .staticperlrc to avoid repeated downloads.
190
144to manually download perl yourself, place 191to manually download perl yourself, place a suitable tarball in
145perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 192$DLCACHE/$PERLTAR
146trying $URL
147EOF
148 193
194either curl or wget is required for automatic download.
195curl is tried first, then wget.
196EOF
197
149 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 198 rm -f $PERLTAR~ # just to be on the safe side
150 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 199 { [ "$DLCACHE" ] && cp "$DLCACHE"/$PERLTAR $PERLTAR~ >/dev/null 2>&1; } \
151 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 200 || wget -O $PERLTAR~ "$PERLURL" \
201 || curl -f >$PERLTAR~ "$PERLURL" \
152 || fatal "$URL: unable to download" 202 || fatal "$URL: unable to download"
153 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 203 rm -f $PERLTAR
204 mv $PERLTAR~ $PERLTAR
205 if [ "$DLCACHE" ]; then
206 mkdir -p "$DLCACHE"
207 cp $PERLTAR "$DLCACHE"/$PERLTAR~$$~ && \
208 mv "$DLCACHE"/$PERLTAR~$$~ "$DLCACHE"/$PERLTAR
209 fi
154 fi 210 fi
155 211
156 verblock <<EOF 212 verblock <<EOF
157unpacking perl 213unpacking perl
158EOF 214EOF
159 215
160 mkdir -p unpack 216 case "$PERLTAR" in
161 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \ 217 *.xz ) UNCOMPRESS="xz -d" ;;
218 *.lzma ) UNCOMPRESS="lzma -d" ;;
219 *.bz2 ) UNCOMPRESS="bzip2 -d" ;;
220 *.gz ) UNCOMPRESS="gzip -d" ;;
221 *.tar ) UNCOMPRESS="cat" ;;
222 * )
223 fatal "don't know hot to uncompress $PERLTAR,\nonly tar, tar.gz, tar.bz2, tar.lzma and tar.xz are supported."
224 exit 1
225 ;;
226 esac
227
228 <"$PERLTAR" $UNCOMPRESS -d | ( cd unpack && tar xf - ) \
162 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 229 || fatal "$PERLTAR: error during unpacking"
163 chmod -R u+w unpack/perl-$PERL_VERSION 230
164 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 231 if [ -d unpack/*/ ]; then
232 chmod -R u+w unpack/*/
233 mv unpack/*/ perl
165 rmdir -p unpack 234 rmdir -p unpack
235 else
236 fatal "unpacking $PERLTAR did not result in a single directory, don't know how to handle this"
237 fi
238
239 rm "$PERLTAR"
166 fi 240 fi
241) || exit
167} 242}
168 243
169# similar to GNU-sed -i or perl -pi 244# similar to GNU-sed -i or perl -pi
170sedreplace() { 245sedreplace() {
171 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 246 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
247 rm -f "$2"
172 mv "$2~" "$2" 248 mv "$2~" "$2"
173} 249}
174 250
251configure_failure() {
252 cat <<EOF
253
254
255***
256*** Configure failed - see above for the exact error message(s).
257***
258*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
259*** flags are not supported by your compiler. Less often, this is because
260*** PERL_LIBS either contains a library not available on your system (such as
261*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
262***
263*** You can provide your own flags by creating a ~/.staticperlrc file with
264*** variable assignments. For example (these are the actual values used):
265***
266
267PERL_CC="$PERL_CC"
268PERL_CCFLAGS="$PERL_CCFLAGS"
269PERL_OPTIMIZE="$PERL_OPTIMIZE"
270PERL_LDFLAGS="$PERL_LDFLAGS"
271PERL_LIBS="$PERL_LIBS"
272
273EOF
274 exit 1
275}
276
175configure() { 277configure() {
278(
176 fetch 279 fetch
177 280
178 rcd "$STATICPERL/src/perl-$PERL_VERSION" 281 rcd "$STATICPERL/src/perl"
179 282
180 [ -e staticstamp.configure ] && return 283 [ -e staticstamp.configure ] && return
181 284
182 verblock <<EOF 285 verblock <<EOF
183configuring $STATICPERL/src/perl-$PERL_VERSION 286configuring $STATICPERL/src/perl
184EOF 287EOF
185 288
186 rm -f "$PERL_PREFIX/staticstamp.install" 289 rm -f "$PERL_PREFIX/staticstamp.install"
187 290
188 make distclean >/dev/null 2>&1 291 "$MAKE" distclean >/dev/null 2>&1
189 292
293 sedreplace '/^#define SITELIB/d' config_h.SH
294
190 # I hate them 295 # I hate them for this
191 grep -q -- -fstack-protector Configure && \ 296 grep -q -- -fstack-protector Configure && \
192 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 297 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
193 298
194 preconfigure 299 # what did that bloke think
300 grep -q -- usedl=.define hints/darwin.sh && \
301 sedreplace '/^usedl=.define.;$/d' hints/darwin.sh
302
303 preconfigure || fatal "preconfigure hook failed"
195 304
196# trace configure \ 305# trace configure \
197 sh Configure -Duselargefiles \ 306 sh Configure -Duselargefiles \
198 -Uuse64bitint \ 307 -Uuse64bitint \
199 -Dusemymalloc=n \ 308 -Dusemymalloc=n \
201 -Uusethreads \ 310 -Uusethreads \
202 -Uuseithreads \ 311 -Uuseithreads \
203 -Uusemultiplicity \ 312 -Uusemultiplicity \
204 -Uusesfio \ 313 -Uusesfio \
205 -Uuseshrplib \ 314 -Uuseshrplib \
315 -Uinstallusrbinperl \
316 -A ccflags=" $PERL_CCFLAGS" \
206 -Dcc="$PERL_CC" \ 317 -Dcc="$PERL_CC" \
207 -Dcppflags="$PERL_CPPFLAGS" \
208 -Dccflags="-g2 -fno-strict-aliasing" \
209 -Doptimize="$PERL_OPTIMIZE" \ 318 -Doptimize="$PERL_OPTIMIZE" \
210 -Dldflags="$PERL_LDFLAGS" \ 319 -Dldflags="$PERL_LDFLAGS" \
211 -Dlibs="$PERL_LIBS" \ 320 -Dlibs="$PERL_LIBS" \
212 -Dprefix="$PERL_PREFIX" \ 321 -Dprefix="$PERL_PREFIX" \
213 -Dbin="$PERL_PREFIX/bin" \ 322 -Dbin="$PERL_PREFIX/bin" \
214 -Dprivlib="$PERL_PREFIX/lib" \ 323 -Dprivlib="$PERL_PREFIX/lib" \
215 -Darchlib="$PERL_PREFIX/lib" \ 324 -Darchlib="$PERL_PREFIX/lib" \
216 -Uusevendorprefix \ 325 -Uusevendorprefix \
217 -Dsitelib="$PERL_PREFIX/lib" \ 326 -Dsitelib="$PERL_PREFIX/lib" \
218 -Dsitearch="$PERL_PREFIX/lib" \ 327 -Dsitearch="$PERL_PREFIX/lib" \
219 -Usitelibexp \
220 -Uman1dir \ 328 -Uman1dir \
221 -Uman3dir \ 329 -Uman3dir \
222 -Usiteman1dir \ 330 -Usiteman1dir \
223 -Usiteman3dir \ 331 -Usiteman3dir \
224 -Dpager=/usr/bin/less \ 332 -Dpager=/usr/bin/less \
225 -Demail="$EMAIL" \ 333 -Demail="$EMAIL" \
226 -Dcf_email="$EMAIL" \ 334 -Dcf_email="$EMAIL" \
227 -Dcf_by="$EMAIL" \ 335 -Dcf_by="$EMAIL" \
228 $PERL_CONFIGURE \ 336 $PERL_CONFIGURE \
229 -Duseperlio \ 337 -Duseperlio \
338 -Uversiononly \
230 -dE || fatal "Configure failed" 339 -dE || configure_failure
231 340
232 sedreplace ' 341 sedreplace '
233 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 342 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
234 s/ *-fno-stack-protector */ /g 343 s/ *-fno-stack-protector */ /g
235 ' config.sh 344 ' config.sh
236 345
346 patchconfig || fatal "patchconfig hook failed"
347
237 sh Configure -S || fatal "Configure -S failed" 348 sh Configure -S || fatal "Configure -S failed"
238 349
239 postconfigure || fatal "postconfigure hook failed" 350 postconfigure || fatal "postconfigure hook failed"
240 351
241 touch staticstamp.configure 352 : > staticstamp.configure
353) || exit
354}
355
356write_shellscript() {
357 {
358 echo "#!/bin/sh"
359 echo "STATICPERL=\"$STATICPERL\""
360 echo "PERL_PREFIX=\"$PERL_PREFIX\""
361 echo "MAKE=\"$MAKE\""
362 cat
363 } >"$PERL_PREFIX/bin/$1"
364 chmod 755 "$PERL_PREFIX/bin/$1"
242} 365}
243 366
244build() { 367build() {
368(
245 configure 369 configure
246 370
247 rcd "$STATICPERL/src/perl-$PERL_VERSION" 371 rcd "$STATICPERL/src/perl"
248 372
249 verblock <<EOF 373 verblock <<EOF
250building $STATICPERL/src/perl-$PERL_VERSION 374building $STATICPERL/src/perl
251EOF 375EOF
252 376
253 rm -f "$PERL_PREFIX/staticstamp.install" 377 rm -f "$PERL_PREFIX/staticstamp.install"
254 378
255 make || fatal "make: error while building perl" 379 "$MAKE" || fatal "make: error while building perl"
256 380
257 postbuild || fatal "postbuild hook failed" 381 postbuild || fatal "postbuild hook failed"
382) || exit
383}
384
385_postinstall() {
386 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
387 NOCHECK_INSTALL=+
388 instcpan $STATICPERL_MODULES
389 [ "$EXTRA_MODULES" ] && instcpan $EXTRA_MODULES
390
391 postinstall || fatal "postinstall hook failed"
392
393 : > "$PERL_PREFIX/staticstamp.postinstall"
394 fi
258} 395}
259 396
260install() { 397install() {
398(
261 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then 399 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
262 build 400 build
263 401
264 verblock <<EOF 402 verblock <<EOF
265installing $STATICPERL/src/perl-$PERL_VERSION 403installing $STATICPERL/src/perl
266to $PERL_PREFIX 404to $PERL_PREFIX
267EOF 405EOF
268 406
269 ln -sf "perl/bin/" "$STATICPERL/bin" 407 ln -sf "perl/bin/" "$STATICPERL/bin"
270 ln -sf "perl/lib/" "$STATICPERL/lib" 408 ln -sf "perl/lib/" "$STATICPERL/lib"
271 409
410 mkdir "$STATICPERL/patched"
411
272 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten 412 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
273 rm -rf "$PERL_PREFIX" # by this rm -rf 413 rm -rf "$PERL_PREFIX" # by this rm -rf
274 414
415 rcd "$STATICPERL/src/perl"
416
275 make install || fatal "make install: error while installing" 417 "$MAKE" install || fatal "make install: error while installing"
276 418
277 rcd "$PERL_PREFIX" 419 rcd "$PERL_PREFIX"
278 420
279 # create a "make install" replacement for CPAN 421 # create a "make install" replacement for CPAN
280 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 422 write_shellscript SP-make-make <<'end_of_make'
281make || exit 423#CAT make-make.sh
424end_of_make
282 425
283if find blib/arch/auto -type f | grep -q -v .exists; then 426 # create a "make install" replacement for CPAN
284 echo Probably an XS module, rebuilding perl 427 write_shellscript SP-make-install-make <<'end_of_make_install_make'
285 if make perl; then 428#CAT make-install-make.sh
286 mv perl "$PERL_PREFIX"/bin/perl 429end_of_make_install_make
287 make -f Makefile.aperl map_clean
288 else
289 make -f Makefile.aperl map_clean
290 exit 1
291 fi
292fi
293 430
294make install UNINST=1 431 # create a "patch modules" helper
295EOF 432 write_shellscript SP-patch-postinstall <<'end_of_patch_postinstall'
296 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install 433#CAT patch-postinstall.sh
434end_of_patch_postinstall
297 435
436 # immediately use it
437 "$PERL_PREFIX/bin/SP-patch-postinstall"
438
298 # trick CPAN into avoiding ~/.cpan completely 439 # help to trick CPAN into avoiding ~/.cpan completely
299 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 440 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
300 441
442 # we call cpan with -MCPAN::MyConfig in this script, which
443 # is strictly unnecessary as we have to patch CPAN anyway,
444 # so consider it "for good measure".
301 "$PERL_PREFIX"/bin/perl -MCPAN -e ' 445 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e '
302 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 446 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
447 CPAN::Shell->o (conf => pushy_https => "0");
303 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 448 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
304 CPAN::Shell->o (conf => q<init>); 449 CPAN::Shell->o (conf => q<init>);
305 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 450 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
306 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 451 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
307 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 452 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
308 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 453 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
309 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 454 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
455 CPAN::Shell->o (conf => q<makepl_arg>, "MAP_TARGET=perl");
456 CPAN::Shell->o (conf => q<make>, "'"$PERL_PREFIX"'/bin/SP-make-make");
310 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install"); 457 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/SP-make-install-make");
311 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 458 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
312 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 459 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<yes>);
460 CPAN::Shell->o (conf => q<recommends_policy>, q<0>);
461 CPAN::Shell->o (conf => q<suggests_policy>, q<0>);
462 CPAN::Shell->o (conf => q<prefer_installer>, q<EUMM>);
313 CPAN::Shell->o (conf => q<commit>); 463 CPAN::Shell->o (conf => q<commit>);
314 ' || fatal "error while initialising CPAN" 464 ' || fatal "error while initialising CPAN"
315 465
466 postcpanconfig
467
316 touch "$PERL_PREFIX/staticstamp.install" 468 : > "$PERL_PREFIX/staticstamp.install"
317 fi 469 fi
318 470
471 _postinstall
472) || exit
473}
474
475import() {
476(
477 IMPORT="$1"
478
479 rcd "$STATICPERL"
480
319 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then 481 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
320 NOCHECK_INSTALL=+ 482 verblock <<EOF
321 instcpan $STATICPERL_MODULES 483import perl from $IMPORT to $STATICPERL
322 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES 484EOF
323 485
324 postinstall || fatal "postinstall hook failed" 486 rm -rf bin cpan lib patched perl src
487 mkdir -m 755 perl perl/bin
488 ln -s perl/bin/ bin
489 ln -s "$IMPORT" perl/bin/
325 490
491 echo "$IMPORT" > "$PERL_PREFIX/.import"
492
326 touch "$PERL_PREFIX/staticstamp.postinstall" 493 : > "$PERL_PREFIX/staticstamp.install"
327 fi 494 fi
495
496 _postinstall
497) || exit
328} 498}
329 499
330############################################################################# 500#############################################################################
331# install a module from CPAN 501# install a module from CPAN
332 502
333instcpan() { 503instcpan() {
334 [ $NOCHECK_INSTALL ] || install 504 [ $NOCHECK_INSTALL ] || install
335 505
336 verblock <<EOF 506 verblock <<EOF
337installing modules from CPAN 507installing modules from CPAN
338$@ 508$*
339EOF 509EOF
340 510
341 for mod in "$@"; do 511 MYCONFIG=
342 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 512 [ -e "$PERL_PREFIX/.import" ] || MYCONFIG=-MCPAN::MyConfig
343 || fatal "$mod: unable to install from CPAN" 513
344 done 514 "$PERL_PREFIX"/bin/perl $MYCONFIG -MCPAN -e 'notest (install => $_) for @ARGV' -- "$@" | tee "$STATICPERL/instcpan.log"
515
516 if grep -q " -- NOT OK\$" "$STATICPERL/instcpan.log"; then
517 fatal "failure while installing modules from CPAN ($*)"
518 fi
345 rm -rf "$STATICPERL/build" 519 rm -f "$STATICPERL/instcpan.log"
346} 520}
347 521
348############################################################################# 522#############################################################################
349# install a module from unpacked sources 523# install a module from unpacked sources
350 524
351instsrc() { 525instsrc() {
352 [ $NOCHECK_INSTALL ] || install 526 [ $NOCHECK_INSTALL ] || install
353 527
354 verblock <<EOF 528 verblock <<EOF
355installing modules from source 529installing modules from source
356$@ 530$*
357EOF 531EOF
358 532
359 for mod in "$@"; do 533 for mod in "$@"; do
360 echo 534 echo
361 echo $mod 535 echo $mod
362 ( 536 (
363 rcd $mod 537 rcd $mod
364 make -f Makefile.aperl map_clean >/dev/null 2>&1 538 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
365 make distclean >/dev/null 2>&1 539 "$MAKE" distclean >/dev/null 2>&1
366 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 540 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
367 make || fatal "$mod: error building module" 541 "$MAKE" || fatal "$mod: error building module"
368 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 542 "$PERL_PREFIX"/bin/SP-make-install-make install || fatal "$mod: error installing module"
369 make distclean >/dev/null 2>&1 543 "$MAKE" distclean >/dev/null 2>&1
370 exit 0 544 exit 0
371 ) || exit $? 545 ) || exit $?
372 done 546 done
373} 547}
374 548
399catmkbundle() { 573catmkbundle() {
400 { 574 {
401 read dummy 575 read dummy
402 echo "#!$PERL_PREFIX/bin/perl" 576 echo "#!$PERL_PREFIX/bin/perl"
403 cat 577 cat
404 } <<'MKBUNDLE' 578 } <<'end_of_mkbundle'
405#CAT mkbundle 579#CAT mkbundle
406MKBUNDLE 580end_of_mkbundle
407} 581}
408 582
409bundle() { 583bundle() {
584 MKBUNDLE="${MKBUNDLE:=$PERL_PREFIX/bin/SP-mkbundle}"
410 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 585 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
411 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 586 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
412 CACHE="$STATICPERL/cache" 587 CACHE="$STATICPERL/cache"
413 mkdir -p "$CACHE" 588 mkdir -p "$CACHE"
414 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@" 589 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
422 command="${1#--}"; shift 597 command="${1#--}"; shift
423 case "$command" in 598 case "$command" in
424 version ) 599 version )
425 echo "staticperl version $VERSION" 600 echo "staticperl version $VERSION"
426 ;; 601 ;;
427 fetch | configure | build | install | clean | distclean) 602 fetch | configure | build | install | clean | realclean | distclean )
428 ( "$command" ) 603 ( "$command" ) || exit
604 ;;
605 import )
606 ( import "$1" ) || exit
607 shift
429 ;; 608 ;;
430 instsrc ) 609 instsrc )
431 ( instsrc "$@" ) 610 ( instsrc "$@" ) || exit
432 exit 611 exit
433 ;; 612 ;;
434 instcpan ) 613 instcpan )
435 ( instcpan "$@" ) 614 ( instcpan "$@" ) || exit
436 exit 615 exit
437 ;; 616 ;;
617 perl )
618 ( install ) || exit
619 exec "$PERL_PREFIX/bin/perl" "$@"
620 exit
621 ;;
438 cpan ) 622 cpan )
439 ( install ) 623 ( install ) || exit
624 PERL="$PERL_PREFIX/bin/perl"
625 export PERL
440 "$PERL_PREFIX/bin/cpan" "$@" 626 exec "$PERL_PREFIX/bin/cpan" "$@"
441 exit 627 exit
442 ;; 628 ;;
443 mkbundle ) 629 mkbundle )
444 ( install ) 630 ( install ) || exit
445 bundle "$@" 631 bundle "$@"
446 exit 632 exit
447 ;; 633 ;;
448 mkperl ) 634 mkperl )
449 ( install ) 635 ( install ) || exit
450 bundle --perl "$@" 636 bundle --perl "$@"
451 exit 637 exit
452 ;; 638 ;;
453 mkapp ) 639 mkapp )
454 ( install ) 640 ( install ) || exit
455 bundle --app "$@" 641 bundle --app "$@"
456 exit 642 exit
457 ;; 643 ;;
458 help ) 644 help )
459 podusage 2 645 podusage 2

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines